commit f0a6eca4f74069613ae324b645498827b96a7679
Author: jklowden <jklowden>
Date:   Wed Apr 23 21:36:01 2008 +0000

    add tdsdump_col()

diff --git a/include/tds.h b/include/tds.h
index 1a5eafa..50d0282 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.285 2008/01/18 13:37:12 freddy77 Exp $ */
+/* $Id: tds.h,v 1.286 2008/04/23 21:36:01 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1535,18 +1535,22 @@ void tds_set_parent(TDSSOCKET * tds, void *the_parent);
 void *tds_get_parent(TDSSOCKET * tds);
 int tds_swap_bytes(unsigned char *buf, int bytes);
 int tds_version(TDSSOCKET * tds_socket, char *pversion_string);
+unsigned int tds_gettime_ms(void);
+
+/* log.c */
 void tdsdump_off(void);
 void tdsdump_on(void);
 int tdsdump_open(const char *filename);
 void tdsdump_close(void);
 void tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, const void *buf, int length);
-void tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...) 
+void tdsdump_col(const TDSCOLUMN *col);
+void tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
+
 #if defined(__GNUC__) && __GNUC__ >= 2
 	__attribute__ ((__format__ (__printf__, 3, 4)))
 #endif
 ;
 extern int tds_debug_flags;
-unsigned int tds_gettime_ms(void);
 
 /* net.c */
 int tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int timeout);
diff --git a/src/tds/log.c b/src/tds/log.c
index 2de151f..4c9ee5d 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.4 2007/11/12 22:17:28 jklowden Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.5 2008/04/23 21:36:01 jklowden Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALLLVL | TDS_DBGFLAG_SOURCE;
@@ -111,7 +111,7 @@ tdsdump_on(void)
 
 
 /**
- * This creates and truncates a human readable dump file for the TDS
+ * Create and truncate a human readable dump file for the TDS
  * traffic.  The name of the file is specified by the filename
  * parameter.  If that is given as NULL or an empty string,
  * any existing log file will be closed.
@@ -362,7 +362,7 @@ tdsdump_dump_buf(const char* file, unsigned int level_line, const char *msg, con
 
 
 /**
- * This function write a message to the debug log.  
+ * Write a message to the debug log.  
  * \param file name of the log file
  * \param level_line kind of detail to be included
  * \param fmt       printf-like format string
@@ -415,3 +415,79 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 }				/* tdsdump_log()  */
 
+/**
+ * Write a column value to the debug log.  
+ * \param file name of the log file
+ * \param col column to dump
+ */
+void
+tdsdump_col(const TDSCOLUMN *col)
+{
+	const char* typename;
+	char* data;
+	TDS_SMALLINT type;
+	
+	assert(col);
+	assert(col->column_data);
+	
+	typename = tds_prtype(col->column_type);
+	type = col->column_type;
+	
+	switch(type) {
+	case SYBINTN:
+		switch(col->column_cur_size) {
+		case sizeof(TDS_INT):
+			type = SYBINT4;
+			break;
+		case sizeof(TDS_SMALLINT):
+			type = SYBINT2;
+			break;
+		case sizeof(TDS_TINYINT):
+			type = SYBINT1;
+			break;
+		}
+		break;
+	case SYBFLTN:
+		switch(col->column_cur_size) {
+		case sizeof(TDS_REAL):
+			type = SYBREAL;
+			break;
+		case sizeof(TDS_FLOAT):
+			type = SYBFLT8;
+			break;
+		}
+		break;
+	}
+	
+	switch(type) {
+	case SYBCHAR: 
+	case SYBVARCHAR: 
+		data = calloc(1, 1 + col->column_cur_size);
+		if( !data ) {
+			tdsdump_log(TDS_DBG_FUNC, "no memory to log data for type %s\n", typename);
+			return;
+		}
+		memcpy(data, col->column_data, col->column_cur_size);
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value \"%s\"\n", typename, data); 
+		free(data);
+		break;
+	case SYBINT1: 
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value %d\n", typename, (int)*(TDS_TINYINT*)col->column_data); 
+		break;
+	case SYBINT2: 
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value %d\n", typename, (int)*(TDS_SMALLINT*)col->column_data); 
+		break;
+	case SYBINT4: 
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value %d\n", typename, (int)*(TDS_INT*)col->column_data); 
+		break;
+	case SYBREAL: 
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value %f\n", typename, (double)*(TDS_REAL*)col->column_data); 
+		break;
+	case SYBFLT8: 
+		tdsdump_log(TDS_DBG_FUNC, "type %s has value %d\n", typename, (double)*(TDS_FLOAT*)col->column_data); 
+		break;
+	default:
+		tdsdump_log(TDS_DBG_FUNC, "cannot log data for type %s\n", typename);
+		break;
+	}
+}
diff --git a/src/tds/login.c b/src/tds/login.c
index 1bcbd0c..58deec6 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.172 2007/12/31 10:06:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.173 2008/04/23 21:36:01 jklowden Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -533,6 +533,9 @@ tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	int len;
 	char blockstr[16];
 
+	/* override lservname field for ASA servers */	
+	const char *lservname = getenv("ASA_DATABASE")? getenv("ASA_DATABASE") : tds_dstr_cstr(&connection->server_name);
+
 	if (strchr(tds_dstr_cstr(&connection->user_name), '\\') != NULL) {
 		tdsdump_log(TDS_DBG_ERROR, "NT login not support using TDS 4.x or 5.0\n");
 		return TDS_FAIL;
@@ -579,7 +582,7 @@ tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 	}
 	tds_put_n(tds, magic3, 3);
 	tds_put_login_string(tds, tds_dstr_cstr(&connection->app_name), TDS_MAX_LOGIN_STR_SZ);
-	tds_put_login_string(tds, tds_dstr_cstr(&connection->server_name), TDS_MAX_LOGIN_STR_SZ);
+	tds_put_login_string(tds, lservname, TDS_MAX_LOGIN_STR_SZ);
 	if (IS_TDS42(tds)) {
 		tds_put_login_string(tds, tds_dstr_cstr(&connection->password), 255);
 	} else {
diff --git a/src/tds/token.c b/src/tds/token.c
index e6d5a6d..445c4b1 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.344 2008/01/13 20:01:45 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.345 2008/04/23 21:36:01 jklowden Exp $");
 
 static int tds_process_msg(TDSSOCKET * tds, int marker);
 static int tds_process_compute_result(TDSSOCKET * tds);
@@ -1223,6 +1223,7 @@ tds_process_param_result(TDSSOCKET * tds, TDSPARAMINFO ** pinfo)
 		return TDS_FAIL;
 
 	token = tds_get_data(tds, curparam);
+	tdsdump_col(curparam);
 
 	/*
 	 * Real output parameters will either be unnamed or will have a valid
@@ -1573,6 +1574,8 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 	CHECK_TDS_EXTRA(tds);
 	CHECK_COLUMN_EXTRA(curcol);
 
+	tdsdump_log(TDS_DBG_INFO1, "tds_get_data_info(%p, %p, %d) %s", tds, curcol, is_param, is_param? "[for parameter]" : "");
+
 	curcol->column_namelen = tds_get_string(tds, tds_get_byte(tds), curcol->column_name, sizeof(curcol->column_name) - 1);
 	curcol->column_name[curcol->column_namelen] = '\0';
 
@@ -1585,11 +1588,52 @@ tds_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int is_param)
 		curcol->column_writeable = (curcol->column_flags & 0x10) > 1;
 		curcol->column_nullable = (curcol->column_flags & 0x20) > 1;
 		curcol->column_identity = (curcol->column_flags & 0x40) > 1;
-	}
-	/* TODO what's these bytes ?? */
-	if (IS_TDS90(tds))
-		tds_get_n(tds, NULL, 2);
+#if 0
+		/****************************************
+		 * NumParts=BYTE; (introduced in TDS 7.2) 
+		 * PartName=US_VARCHAR;(introduced in TDS 7.2) 
+		 * TableName=NumParts, {PartName}-; 
+		 * ColName= HYPERLINK \l "B_VARCHAR_Def" B_VARCHAR; 
+		 * ColumnData=UserType, Flags, [TableName], // <Only specified if text, //ntext or image columns are included //in the rowset being described> ColName; 
+		 * NoMetaData='0xFF', '0xFF';
+		 */
+		enum column_flag_bits_according_to_microsoft {
+			  case_sensitive	= 0x0001
+			, nullable		= 0x0002
+			, updateable		= 0x0004
+			, might_be_updateable	= 0x0008
+			, identity		= 0x0010
+			, computed		= 0x0020
+			, us_reserved_odbc	= 0x0040 | 0x0080
+			, is_fixed_len_clr_type = 0x0100
+			, is_hidden_browse_pk	= 0x0200
+			, is_browse_pk		= 0x0400
+			, might_be_nullable	= 0x0800 
+		};
+		/* TODO: implement members in TDSCOLUMN */
+		if (IS_TDS90(tds)) {
+			curcol->is_computed = 		(curcol->column_flags & (1 << 4)) > 1;
+			curcol->us_reserved_odbc1 = 	(curcol->column_flags & (1 << 5)) > 1;
+			curcol->us_reserved_odbc2 = 	(curcol->column_flags & (1 << 6)) > 1;
+			curcol->is_fixed_len_clr_type = (curcol->column_flags & (1 << 7)) > 1;
+		}
+#endif 
+	} 
 
+	if (IS_TDS90(tds)) {
+		tds_get_n(tds, NULL, 2);
+#if 0
+		/* TODO: implement members in TDSCOLUMN, values untested */
+		curcol->us_reserved1 = (curcol->column_flags & 0x01);
+		curcol->us_reserved2 = (curcol->column_flags & 0x02);
+		curcol->us_reserved3 = (curcol->column_flags & 0x04);
+		curcol->us_reserved4 = (curcol->column_flags & 0x08);
+		curcol->is_hidden = (curcol->column_flags & 0x10);
+		curcol->is_key = (curcol->column_flags & 0x20);
+		curcol->is_nullable_unknown = (curcol->column_flags & 0x40);
+#endif
+	}
+	
 	curcol->column_usertype = tds_get_int(tds);
 	tds_set_column_type(tds, curcol, tds_get_byte(tds));
 

